"use strict";
/**
 * Copyright 2019 Google Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CDPElementHandle = void 0;
const ElementHandle_js_1 = require("../api/ElementHandle.js");
const assert_js_1 = require("../util/assert.js");
const decorators_js_1 = require("../util/decorators.js");
const JSHandle_js_1 = require("./JSHandle.js");
const util_js_1 = require("./util.js");
/**
 * The CDPElementHandle extends ElementHandle now to keep compatibility
 * with `instanceof` because of that we need to have methods for
 * CDPJSHandle to in this implementation as well.
 *
 * @internal
 */
let CDPElementHandle = (() => {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    let _classSuper = ElementHandle_js_1.ElementHandle;
    let _instanceExtraInitializers = [];
    let _contentFrame_decorators;
    let _scrollIntoView_decorators;
    let _drag_decorators;
    let _dragEnter_decorators;
    let _dragOver_decorators;
    let _drop_decorators;
    let _dragAndDrop_decorators;
    let _uploadFile_decorators;
    let _screenshot_decorators;
    let _autofill_decorators;
    return class CDPElementHandle extends _classSuper {
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _contentFrame_decorators = [(0, decorators_js_1.throwIfDisposed)()];
            _scrollIntoView_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_a = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_a)];
            _drag_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_b = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_b)];
            _dragEnter_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_c = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_c)];
            _dragOver_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_d = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_d)];
            _drop_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_e = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_e)];
            _dragAndDrop_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_f = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_f)];
            _uploadFile_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_g = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_g)];
            _screenshot_decorators = [(0, decorators_js_1.throwIfDisposed)(), (_h = ElementHandle_js_1.ElementHandle).bindIsolatedHandle.bind(_h)];
            _autofill_decorators = [(0, decorators_js_1.throwIfDisposed)()];
            __esDecorate(this, null, _contentFrame_decorators, { kind: "method", name: "contentFrame", static: false, private: false, access: { has: obj => "contentFrame" in obj, get: obj => obj.contentFrame }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _scrollIntoView_decorators, { kind: "method", name: "scrollIntoView", static: false, private: false, access: { has: obj => "scrollIntoView" in obj, get: obj => obj.scrollIntoView }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _drag_decorators, { kind: "method", name: "drag", static: false, private: false, access: { has: obj => "drag" in obj, get: obj => obj.drag }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _dragEnter_decorators, { kind: "method", name: "dragEnter", static: false, private: false, access: { has: obj => "dragEnter" in obj, get: obj => obj.dragEnter }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _dragOver_decorators, { kind: "method", name: "dragOver", static: false, private: false, access: { has: obj => "dragOver" in obj, get: obj => obj.dragOver }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _drop_decorators, { kind: "method", name: "drop", static: false, private: false, access: { has: obj => "drop" in obj, get: obj => obj.drop }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _dragAndDrop_decorators, { kind: "method", name: "dragAndDrop", static: false, private: false, access: { has: obj => "dragAndDrop" in obj, get: obj => obj.dragAndDrop }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _uploadFile_decorators, { kind: "method", name: "uploadFile", static: false, private: false, access: { has: obj => "uploadFile" in obj, get: obj => obj.uploadFile }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _screenshot_decorators, { kind: "method", name: "screenshot", static: false, private: false, access: { has: obj => "screenshot" in obj, get: obj => obj.screenshot }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(this, null, _autofill_decorators, { kind: "method", name: "autofill", static: false, private: false, access: { has: obj => "autofill" in obj, get: obj => obj.autofill }, metadata: _metadata }, null, _instanceExtraInitializers);
            if (_metadata) Object.defineProperty(this, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        constructor(world, remoteObject) {
            super(new JSHandle_js_1.CDPJSHandle(world, remoteObject));
            __runInitializers(this, _instanceExtraInitializers);
        }
        get realm() {
            return this.handle.realm;
        }
        get client() {
            return this.handle.client;
        }
        remoteObject() {
            return this.handle.remoteObject();
        }
        get #frameManager() {
            return this.frame._frameManager;
        }
        get #page() {
            return this.frame.page();
        }
        get frame() {
            return this.realm.environment;
        }
        async contentFrame() {
            const nodeInfo = await this.client.send('DOM.describeNode', {
                objectId: this.id,
            });
            if (typeof nodeInfo.node.frameId !== 'string') {
                return null;
            }
            return this.#frameManager.frame(nodeInfo.node.frameId);
        }
        async scrollIntoView() {
            await this.assertConnectedElement();
            try {
                await this.client.send('DOM.scrollIntoViewIfNeeded', {
                    objectId: this.id,
                });
            }
            catch (error) {
                (0, util_js_1.debugError)(error);
                // Fallback to Element.scrollIntoView if DOM.scrollIntoViewIfNeeded is not supported
                await super.scrollIntoView();
            }
        }
        /**
         * This method creates and captures a dragevent from the element.
         */
        async drag(target) {
            (0, assert_js_1.assert)(this.#page.isDragInterceptionEnabled(), 'Drag Interception is not enabled!');
            await this.scrollIntoViewIfNeeded();
            const start = await this.clickablePoint();
            return await this.#page.mouse.drag(start, target);
        }
        async dragEnter(data = { items: [], dragOperationsMask: 1 }) {
            await this.scrollIntoViewIfNeeded();
            const target = await this.clickablePoint();
            await this.#page.mouse.dragEnter(target, data);
        }
        async dragOver(data = { items: [], dragOperationsMask: 1 }) {
            await this.scrollIntoViewIfNeeded();
            const target = await this.clickablePoint();
            await this.#page.mouse.dragOver(target, data);
        }
        async drop(data = { items: [], dragOperationsMask: 1 }) {
            await this.scrollIntoViewIfNeeded();
            const destination = await this.clickablePoint();
            await this.#page.mouse.drop(destination, data);
        }
        async dragAndDrop(target, options) {
            (0, assert_js_1.assert)(this.#page.isDragInterceptionEnabled(), 'Drag Interception is not enabled!');
            await this.scrollIntoViewIfNeeded();
            const startPoint = await this.clickablePoint();
            const targetPoint = await target.clickablePoint();
            await this.#page.mouse.dragAndDrop(startPoint, targetPoint, options);
        }
        async uploadFile(...filePaths) {
            const isMultiple = await this.evaluate(element => {
                return element.multiple;
            });
            (0, assert_js_1.assert)(filePaths.length <= 1 || isMultiple, 'Multiple file uploads only work with <input type=file multiple>');
            // Locate all files and confirm that they exist.
            let path;
            try {
                path = await Promise.resolve().then(() => __importStar(require('path')));
            }
            catch (error) {
                if (error instanceof TypeError) {
                    throw new Error(`JSHandle#uploadFile can only be used in Node-like environments.`);
                }
                throw error;
            }
            const files = filePaths.map(filePath => {
                if (path.win32.isAbsolute(filePath) || path.posix.isAbsolute(filePath)) {
                    return filePath;
                }
                else {
                    return path.resolve(filePath);
                }
            });
            const { node } = await this.client.send('DOM.describeNode', {
                objectId: this.id,
            });
            const { backendNodeId } = node;
            /*  The zero-length array is a special case, it seems that
                 DOM.setFileInputFiles does not actually update the files in that case,
                 so the solution is to eval the element value to a new FileList directly.
             */
            if (files.length === 0) {
                await this.evaluate(element => {
                    element.files = new DataTransfer().files;
                    // Dispatch events for this case because it should behave akin to a user action.
                    element.dispatchEvent(new Event('input', { bubbles: true }));
                    element.dispatchEvent(new Event('change', { bubbles: true }));
                });
            }
            else {
                await this.client.send('DOM.setFileInputFiles', {
                    objectId: this.id,
                    files,
                    backendNodeId,
                });
            }
        }
        async screenshot(options = {}) {
            let needsViewportReset = false;
            let boundingBox = await this.boundingBox();
            (0, assert_js_1.assert)(boundingBox, 'Node is either not visible or not an HTMLElement');
            const viewport = this.#page.viewport();
            if (viewport &&
                (boundingBox.width > viewport.width ||
                    boundingBox.height > viewport.height)) {
                const newViewport = {
                    width: Math.max(viewport.width, Math.ceil(boundingBox.width)),
                    height: Math.max(viewport.height, Math.ceil(boundingBox.height)),
                };
                await this.#page.setViewport(Object.assign({}, viewport, newViewport));
                needsViewportReset = true;
            }
            await this.scrollIntoViewIfNeeded();
            boundingBox = await this.boundingBox();
            (0, assert_js_1.assert)(boundingBox, 'Node is either not visible or not an HTMLElement');
            (0, assert_js_1.assert)(boundingBox.width !== 0, 'Node has 0 width.');
            (0, assert_js_1.assert)(boundingBox.height !== 0, 'Node has 0 height.');
            const layoutMetrics = await this.client.send('Page.getLayoutMetrics');
            // Fallback to `layoutViewport` in case of using Firefox.
            const { pageX, pageY } = layoutMetrics.cssVisualViewport || layoutMetrics.layoutViewport;
            const clip = Object.assign({}, boundingBox);
            clip.x += pageX;
            clip.y += pageY;
            const imageData = await this.#page.screenshot(Object.assign({}, {
                clip,
            }, options));
            if (needsViewportReset && viewport) {
                await this.#page.setViewport(viewport);
            }
            return imageData;
        }
        async autofill(data) {
            const nodeInfo = await this.client.send('DOM.describeNode', {
                objectId: this.handle.id,
            });
            const fieldId = nodeInfo.node.backendNodeId;
            const frameId = this.frame._id;
            await this.client.send('Autofill.trigger', {
                fieldId,
                frameId,
                card: data.creditCard,
            });
        }
    };
})();
exports.CDPElementHandle = CDPElementHandle;
//# sourceMappingURL=ElementHandle.js.map